!=========================================================================
!  Copyright (C) GemTalk Systems 1986-2014.  All Rights Reserved.
! 
! GbjGciForwarder Class for GBJ 3.0
!
! NOTE:  This class becomes unnecessary when bug 40580 is fixed,
!        as we'll be able use ClientForwarder directly.
!
!  
!
! $Id: GbjGciForwarder.gs $
!
!=========================================================================

doit

ClientForwarder subclass: 'GbjGciForwarder'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: #()
  inDictionary: Globals
%

! Remove existing behavior from GbjGciForwarder
doit
GbjGciForwarder removeAllMethods.
GbjGciForwarder class removeAllMethods.
%
! ------------------- Class methods for GbjGciForwarder
! ------------------- Instance methods for GbjGciForwarder
category: 'Forwarding'
method: GbjGciForwarder
doesNotUnderstand: aMessageDescriptor

" 
Wrapper around ClientForwarder to get around problem with GciContinueWith.

result from ClientForwarder doesNotUnderstand is either a 1 or 2 element array.
If 1, the return value is the single element of the array.
If 2, this is an error return with the errMsg in 1, the stack trace string in 2.
"

| result |
result := super doesNotUnderstand: aMessageDescriptor.

" NOTE: the following code can be removed and replaced with:

  ^ result 

  when bug 40580 is fixed. "

result size = 1 
    ifTrue: [ ^ (result at: 1) ]
    ifFalse: [ 
      System 
         signal: (ErrorSymbols at: #rtErrClientFwd)
         args: result
         signalDictionary:  GemStoneError ]
%
